/*
 * arch/arm/mach-meson6tv/include/mach/gpio.h
 *
 * Copyright (C) 2013 Amlogic, Inc.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __MACH_MESON6TV_GPIO_H
#define __MACH_MESON6TV_GPIO_H

/* Referrence GPIO IRQ definition describled in ISA document #P7.
 */
typedef enum {

	GPIOZ_0 	=	0,
	GPIOZ_1 	=	1,
	GPIOZ_2 	=	2,
	GPIOZ_3 	=	3,
	GPIOZ_4 	=	4,
	GPIOZ_5 	=	5,
	GPIOZ_6 	=	6,
	GPIOZ_7 	=	7,
	GPIOZ_8 	=	8,
	GPIOZ_9 	=	9,
	GPIOZ_10	=	10,
	GPIOZ_11	=	11,
	GPIOZ_12	=	12,
	GPIOZ_13	=	13,
	GPIOZ_14	=	14,
	GPIOZ_15	=	15,
	GPIOZ_16	=	16,
	GPIOZ_17	=	17,
	GPIOZ_18	=	18,
	GPIOZ_19	=	19,

	GPIOY_0		=	20,
	GPIOY_1		=	21,
	GPIOY_2 	=	22,
	GPIOY_3 	=	23,
	GPIOY_4		=	24,
	GPIOY_5		=	25,
	GPIOY_6 	=	26,
	GPIOY_7 	=	27,
	GPIOY_8 	=	28,
	GPIOY_9		=	29,
	GPIOY_10	=	30,
	GPIOY_11	=	31,
	GPIOY_12	=	32,
	GPIOY_13	=	33,
	GPIOY_14	=	34,
	GPIOY_15	=	35,
	GPIOY_16	=	36,
	GPIOY_17	=	37,
	GPIOY_18	=	38,
	GPIOY_19	=	39,
	GPIOY_20	=	40,
	GPIOY_21	=	41,
	GPIOY_22	=	42,
	GPIOY_23	=	43,
	GPIOY_24	=	44,
	GPIOY_25	=	45,
	GPIOY_26	=	46,
	GPIOY_27	=	47,

	GPIOW_0 	=	48,
	GPIOW_1 	=	49,
	GPIOW_2 	=	50,
	GPIOW_3 	=	51,
	GPIOW_4 	=	52,
	GPIOW_5 	=	53,
	GPIOW_6 	=	54,
	GPIOW_7 	=	55,
	GPIOW_8 	=	56,
	GPIOW_9 	=	57,
	GPIOW_10	=	58,
	GPIOW_11	=	59,
	GPIOW_12	=	60,
	GPIOW_13	=	61,
	GPIOW_14	=	62,
	GPIOW_15	=	63,
	GPIOW_16	=	64,
	GPIOW_17	=	65,
	GPIOW_18	=	66,
	GPIOW_19	=	67,

	GPIOX_0		=	68,
	GPIOX_1 	=	69,
	GPIOX_2 	=	70,
	GPIOX_3 	=	71,
	GPIOX_4 	=	72,
	GPIOX_5 	=	73,
	GPIOX_6 	=	74,
	GPIOX_7 	=	75,
	GPIOX_8 	=	76,
	GPIOX_9 	=	77,
	GPIOX_10	=	78,
	GPIOX_11	=	79,
	GPIOX_12	=	80,

	BOOT_0		=	81,
	BOOT_1		=	82,
	BOOT_2		=	83,
	BOOT_3		=	84,
	BOOT_4		=	85,
	BOOT_5		=	86,
	BOOT_6		=	87,
	BOOT_7		=	88,
	BOOT_8		=	89,
	BOOT_9		=	90,
	BOOT_10		=	91,
	BOOT_11		=	92,
	BOOT_12		=	93,
	BOOT_13		=	94,
	BOOT_14		=	95,
	BOOT_15		=	96,
	BOOT_16		=	97,
	BOOT_17		=	98,

	GPIOP_0 	=	99,
	GPIOP_1 	=	100,
	GPIOP_2 	=	101,
	GPIOP_3 	=	102,
	GPIOP_4 	=	103,
	GPIOP_5 	=	104,
	GPIOP_6 	=	105,
	GPIOP_7 	=	106,

	CARD_0		=	107,
	CARD_1		=	108,
	CARD_2		=	109,
	CARD_3		=	110,
	CARD_4		=	111,
	CARD_5		=	112,
	CARD_6		=	113,
	CARD_7		=	114,
	CARD_8		=	115,

	GPIOB_0 	=	116,
	GPIOB_1 	=	117,
	GPIOB_2 	=	118,
	GPIOB_3 	=	119,
	GPIOB_4		=	120,
	GPIOB_5 	=	121,
	GPIOB_6 	=	122,
	GPIOB_7 	=	123,
	GPIOB_8 	=	124,
	GPIOB_9		=	125,
	GPIOB_10	=	126,
	GPIOB_11	=	127,
	GPIOB_12	=	128,
	GPIOB_13	=	129,
	GPIOB_14	=	130,
	GPIOB_15	=	131,
	GPIOB_16	=	132,
	GPIOB_17	=	133,
	GPIOB_18	=	134,
	GPIOB_19	=	135,
	GPIOB_20	=	136,
	GPIOB_21	=	137,
	GPIOB_22	=	138,
	GPIOB_23	=	139,

	GPIOA_0 	=	140,
	GPIOA_1 	=	141,
	GPIOA_2 	=	142,
	GPIOA_3 	=	143,
	GPIOA_4 	=	144,
	GPIOA_5 	=	145,
	GPIOA_6 	=	146,
	GPIOA_7 	=	147,
	GPIOA_8 	=	148,
	GPIOA_9 	=	149,
	GPIOA_10	=	150,
	GPIOA_11	=	151,
	GPIOA_12	=	152,
	GPIOA_13	=	153,
	GPIOA_14	=	154,
	GPIOA_15	=	155,
	GPIOA_16	=	156,
	GPIOA_17	=	157,
	GPIOA_18	=	158,
	GPIOA_19	=	159,
	GPIOA_20	=	160,
	GPIOA_21	=	161,
	GPIOA_22	=	162,
	GPIOA_23	=	163,
	GPIOA_24	=	164,
	GPIOA_25	=	165,
	GPIOA_26	=	166,
	GPIOA_27	=	167,
	GPIOA_28	=	168,
	GPIOA_29	=	169,

	GPIOAO_0 	=	170,
	GPIOAO_1 	=	171,
	GPIOAO_2 	=	172,
	GPIOAO_3 	=	173,
	GPIOAO_4 	=	174,
	GPIOAO_5 	=	175,
	GPIOAO_6 	=	176,
	GPIOAO_7 	=	177,
	GPIOAO_8 	=	178,
	GPIOAO_9 	=	179,
	GPIOAO_10	=	180,
	GPIOAO_11	=	181,

	GPIO_MAX,
}gpio_t;

enum {
	GPIO_IRQ0 = 0,
	GPIO_IRQ1 = 1,
	GPIO_IRQ2 = 2,
	GPIO_IRQ3 = 3,
	GPIO_IRQ4 = 4,
	GPIO_IRQ5 = 5,
	GPIO_IRQ6 = 6,
	GPIO_IRQ7 = 7,
};

enum {
	GPIO_IRQ_HIGH = 0,
	GPIO_IRQ_LOW,
	GPIO_IRQ_RISING,
	GPIO_IRQ_FALLING,
};

enum {
	FILTER_NUM0 = 0,
	FILTER_NUM1,
	FILTER_NUM2,
	FILTER_NUM3,
	FILTER_NUM4,
	FILTER_NUM5,
	FILTER_NUM6,
	FILTER_NUM7,
};


#endif // __MACH_MESON6TV_GPIO_H
